import matplotlib.pyplot as plt
import numpy as np

import FNumber as FN

#--------------------------------------------

plt.figure(num=3)
at = FN.Triangle([-2,-1,3])


plt.subplot(1,2,1); at.plot(); plt.grid(True);
r = at ** 2
print(r, r.singleton_position)
plt.subplot(1,2,2); r.plot(); plt.grid(True);

plt.show()

'''
#--------------------------------------------

plt.figure(num=3)
at = FN.PseudoGaussian([-8,2,4,6], 'pg')

plt.subplot(1,2,1); at.plot(); plt.grid(True);
r = abs(at)
print(r, r.singleton_position)
plt.subplot(1,2,2); r.plot(); plt.grid(True);

plt.show()

#--------------------------------------------

a = FN.Trapezoid([-1,3,5,7],'a')
b = FN.Trapezoid([-1,4,6,9],'b')

x = FN.Triangle([-2,-1,3])
d = FN.Rectangle([-1,3])

c = x*d
c1 = x.ZER_mul(d)

#--------------------------------------------

c = FN.Triangle([-1,0,2], 'ok. 4')
c1 = FN.Singleton(4, 'ok. 4')

s = FN.similarity_measure(c, c1, 1) 
s1 = FN.similarity_measure(c, c1, 2)
s2 = FN.similarity_measure(c, c1, 3)
print('similarity = ',s,s1,s2)

d = FN.distance(c, c1, 1)
d1 = FN.distance(c, c1, 2)
d2 = FN.distance(c, c1, 3, 2)
d3 = FN.distance(c, c1, 4, 2)
d4 = FN.distance(c, c1, 5, 2)
print('distance = ',d,d1,d2,d3,d4)

c.plot(); c1.plot();  plt.grid(True); plt.axis([-9,9,-0.1,1.1]);
plt.show()

#-------------------------------------------- 

a = FN.Trapezoid([1,3,4,5])
b = FN.Trapezoid([1,2,3,4])
c = a*b
c.plot(); plt.grid(True); plt.axis([0,21,-0.1,1.1]);
plt.show()

a = FN.Singleton(4, 'ok. 4')
b = FN.Rectangle([3,5], 'ok. 4')
c = FN.Triangle([3,4,5], 'ok. 4')
c1 = FN.Triangle([3,3,5], 'ok. 3t')
c2 = FN.Triangle([3,5,5], 'ok. 5t')
d = FN.Trapezoid([3,3.5,4.5,5], 'ok. 4')
d1 = FN.Trapezoid([3,3,4,5], 'ok. 4a')
d2 = FN.Trapezoid([3,4,5,5], 'ok. 4b')

ap = FN.Polynomial([1,5,7,8], 'ap')
ap1 = FN.Polynomial([1,5,8,8], 'ap1')
ap2 = FN.Polynomial([1,1,5,8], 'ap1')

ah = FN.Harmonic([1, 5, 7, 8], 'ah')
ah1 = FN.Harmonic([1, 5, 8, 8], 'ah1')
ah2 = FN.Harmonic([1, 1, 6, 8], 'ah1')

ag = FN.PseudoGaussian([1,5,7,8], 'pg')
ag1 = FN.PseudoGaussian([1,5,8,8], 'pg1')
ag2 = FN.PseudoGaussian([1,1,5,8], 'pg2')

plt.figure(num=1)
plt.subplot(4,3,1); a.plot(); b.plot(); plt.axis([2,6,-0.1,1.1]); plt.grid(True); plt.title('Singleton and Rectangular')
plt.subplot(4,3,2); c.plot(); c1.plot(); c2.plot(); plt.axis([2,6,-0.1,1.1]); plt.grid(True); plt.title('Triangle')
plt.subplot(4,3,3); d.plot(); d1.plot(); d2.plot(); plt.axis([2,6,-0.1,1.1]); plt.grid(True); plt.title('Trapezoid')
plt.subplot(4,3,4); ap.plot();  plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Polynomial')
plt.subplot(4,3,5); ap1.plot(); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Polynomial right')
plt.subplot(4,3,6); ap2.plot(); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Polynomial left')
plt.subplot(4,3,7); ah.plot();  plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Harmonic')
plt.subplot(4,3,8); ah1.plot(); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Harmonic right')
plt.subplot(4,3,9); ah2.plot(); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Harmonic left')
plt.subplot(4,3,10); ag.plot();  plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Pseudo Gaussian')
plt.subplot(4,3,11); ag1.plot(); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Pseudo Gaussian right')
plt.subplot(4,3,12); ag2.plot(); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Pseudo Gaussian left')



x = np.arange(1,9,0.125/2.0)
ya = np.zeros_like(x)
yb = np.zeros_like(x)
yc = np.zeros_like(x); yc1 = np.zeros_like(x); yc2 = np.zeros_like(x)
yd = np.zeros_like(x); yd1 = np.zeros_like(x); yd2 = np.zeros_like(x)
yap = np.zeros_like(x); yap1 = np.zeros_like(x); yap2 = np.zeros_like(x)
yah = np.zeros_like(x); yah1 = np.zeros_like(x); yah2 = np.zeros_like(x)
yag = np.zeros_like(x); yag1 = np.zeros_like(x); yag2 = np.zeros_like(x)
for i in range(len(x)):
    ya[i] = a.muValue(x[i])
    yb[i] = b.muValue(x[i])
    yc[i] = c.muValue(x[i]); yc1[i] = c1.muValue(x[i]); yc2[i] = c2.muValue(x[i])
    yd[i] = d.muValue(x[i]); yd1[i] = d1.muValue(x[i]); yd2[i] = d2.muValue(x[i])
    yap[i] = ap.muValue(x[i]); yap1[i] = ap1.muValue(x[i]); yap2[i] = ap2.muValue(x[i])
    yah[i] = ah.muValue(x[i]); yah1[i] = ah1.muValue(x[i]); yah2[i] = ah2.muValue(x[i])
    yag[i] = ag.muValue(x[i]); yag1[i] = ag1.muValue(x[i]); yag2[i] = ag2.muValue(x[i])
    
plt.figure(num=2)
plt.subplot(4,3,1); plt.plot(x,ya); plt.plot(x,yb); plt.grid(True); plt.title('Singleton and Rectangular')
plt.subplot(4,3,2); plt.plot(x,yc); plt.plot(x,yc1); plt.plot(x,yc2); plt.grid(True); plt.title('Triangle')
plt.subplot(4,3,3); plt.plot(x,yd); plt.plot(x,yd1); plt.plot(x,yd2); plt.grid(True); plt.title('Trapezoid')
plt.subplot(4,3,4); plt.plot(x,yap);  plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Polynomial')
plt.subplot(4,3,5); plt.plot(x,yap1); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Polynomial right')
plt.subplot(4,3,6); plt.plot(x,yap2); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Polynomial left')
plt.subplot(4,3,7); plt.plot(x,yah);  plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Harmonic')
plt.subplot(4,3,8); plt.plot(x,yah1); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Harmonic right')
plt.subplot(4,3,9); plt.plot(x,yah2); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Harmonic left')
plt.subplot(4,3,10); plt.plot(x,yag);  plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Pseudo Gaussian')
plt.subplot(4,3,11); plt.plot(x,yag1); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Pseudo Gaussian right')
plt.subplot(4,3,12); plt.plot(x,yag2); plt.axis([0,9,-0.1,1.1]); plt.grid(True); plt.title('Pseudo Gaussian left')

 
    
for x in np.linspace(0.0,1.0,11):
    print('alpha = ', x)
    print(a.alphaValue(x), b.alphaValue(x))
    print(c.alphaValue(x), c1.alphaValue(x), c2.alphaValue(x))
    print(d.alphaValue(x), d1.alphaValue(x), d2.alphaValue(x))
    print(ap.alphaValue(x), ap1.alphaValue(x), ap2.alphaValue(x))
    print(ah.alphaValue(x), ah1.alphaValue(x), ah2.alphaValue(x))
    print(ag.alphaValue(x), ag1.alphaValue(x), ag2.alphaValue(x))



ma = -a
mb = -b
mc = -c
mc1 = -c1
mc2 = -c2
md = -d
md1 = -d1
md2 = -d2

mapf = -ap
map1 = -ap1
map2 = -ap2

mah = -ah
mah1 = -ah1
mah2 = -ah2

mag = -ag
mag1 = -ag1
mag2 = -ag2

plt.figure(num=3)
plt.subplot(4,5,1); a.plot(); ma.plot(); plt.axis([-5,5,-0.1,1.0]); print(a,ma)
plt.subplot(4,5,2); b.plot(); mb.plot(); print(b,mb)
plt.subplot(4,5,3); c.plot(); mc.plot(); print(c,mc)
plt.subplot(4,5,4); c1.plot(); mc1.plot(); print(c1,mc1)
plt.subplot(4,5,5); c2.plot(); mc2.plot(); print(c2,mc2)
plt.subplot(4,5,6); d.plot(); md.plot(); print(d,md)
plt.subplot(4,5,7); d1.plot(); md1.plot(); print(d1,md1)
plt.subplot(4,5,8); d2.plot(); md2.plot(); print(d2,md2)
plt.subplot(4,5,9); ap.plot(); mapf.plot(); print(ap,mapf)
plt.subplot(4,5,10); ap1.plot(); map1.plot(); print(ap1,map1)
plt.subplot(4,5,11); ap2.plot(); map2.plot(); print(ap2,map2)
plt.subplot(4,5,12); ah.plot(); mah.plot(); print(ah,mah)
plt.subplot(4,5,13); ah1.plot(); mah1.plot(); print(ah1,mah1)
plt.subplot(4,5,14); ah2.plot(); mah2.plot(); print(ah2,mah2)
plt.subplot(4,5,15); ag.plot(); mag.plot(); print(ag,mag)
plt.subplot(4,5,16); ag1.plot(); mag1.plot(); print(ag1,mag1)
plt.subplot(4,5,17); ag2.plot(); mag2.plot(); print(ag2,mag2)

plt.show()   
 

'''